(function() {
  var Browsers, CSS, Prefixes, autoprefixer, parse, stringify;

  parse = require('css-parse');

  stringify = require('css-stringify');

  Browsers = require('./autoprefixer/browsers');

  Prefixes = require('./autoprefixer/prefixes');

  CSS = require('./autoprefixer/css');

  autoprefixer = {
    compile: function(str, requirements) {
      var nodes;
      nodes = parse(this.fixIeComments(str));
      this.rework(requirements)(nodes.stylesheet);
      return stringify(nodes);
    },
    rework: function(requirements) {
      var browsers, prefixes;
      browsers = new Browsers(this.data.browsers, requirements);
      prefixes = new Prefixes(this.data.prefixes, browsers);
      return function(stylesheet) {
        var css;
        css = new CSS(stylesheet);
        prefixes.processor.add(css);
        return prefixes.processor.remove(css);
      };
    },
    data: {
      browsers: require('../data/browsers'),
      prefixes: require('../data/prefixes')
    },
    fixIeComments: function(css) {
      return css.replace(/\/\*[^\*]*\*\/\s*:/g, ':');
    },
    inspect: function(requirements) {
      var browsers, prefixes;
      browsers = new Browsers(this.data.browsers, requirements);
      prefixes = new Prefixes(this.data.prefixes, browsers);
      this.inspectFunc || (this.inspectFunc = require('./autoprefixer/inspect'));
      return this.inspectFunc(prefixes);
    }
  };

  module.exports = autoprefixer;

}).call(this);
